﻿namespace HeuristicLab.Problems.ProgramSynthesis.Base.Erc.Char {
  using System;

  using Common;
  using Persistence.Default.CompositeSerializers.Storable;

  [StorableClass]
  public class CharErcOptions : ErcOptionConvertible<char, int> {
    public CharErcOptions() : base(Convert.ToChar) { }

    public CharErcOptions(params IWeightedErcValueItem<int>[] values) : this(true, values) { }

    public CharErcOptions(bool isEnabled, params IWeightedErcValueItem<int>[] values) : base(Convert.ToChar, isEnabled, values) { }

    [StorableConstructor]
    protected CharErcOptions(bool deserializing) : base(deserializing) { }

    public CharErcOptions(CharErcOptions origin, Cloner cloner) : base(origin, cloner) { }

    public override IDeepCloneable Clone(Cloner cloner) {
      return new CharErcOptions(this, cloner);
    }
  }
}
