﻿using System.Linq;

namespace HeuristicLab.Problems.ProgramSynthesis.Base.Erc.FloatVector {
  using HeuristicLab.Common;
  using HeuristicLab.Data;
  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;

  [StorableClass]
  public class FloatVectorConstantsErcValue : VectorConstantsErcValue<double, DoubleArray> {
    public FloatVectorConstantsErcValue() : this(new double[0][]) { }

    public FloatVectorConstantsErcValue(params double[][] values)
      : this(true, values) {
    }

    public FloatVectorConstantsErcValue(bool isEnabled, params double[][] values)
      : base(isEnabled, values.Select(v => new DoubleArray(v)).ToArray()) {
      Name = "Float vector constants";
    }

    [StorableConstructor]
    protected FloatVectorConstantsErcValue(bool deserializing)
      : base(deserializing) {
    }

    public FloatVectorConstantsErcValue(FloatVectorConstantsErcValue origin, Cloner cloner)
      : base(origin, cloner) {
    }

    public override IDeepCloneable Clone(Cloner cloner) {
      return new FloatVectorConstantsErcValue(this, cloner);
    }
  }
}
